﻿using System;
using System.Threading;

namespace CountDownTimer
{
    // Bart De Smet, page 848
    public class CountDown
    {
        private readonly uint _seconds;

        // System.Action delegate: No parameter, nothing returned
        public Action Finished { get; set; }

        // Action<T> delegate: One parameter, nothing returned
        public Action<uint> Tick { get; set; }
        

        public CountDown(uint seconds)
        {
            _seconds = seconds;
        }

        public void Start()
        {
            new Thread(() =>
            {
                uint n = _seconds;
                while (n > 0u)
                {
                    if (Tick != null) Tick(n);
                    Thread.Sleep(1000);
                    n--;
                }
                if (Finished != null) 
                    Finished();
            }).Start();
        }
    }
}
